diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/vps/vps_ddb.c head/sys/vps/vps_ddb.c
--- clean-head/sys/vps/vps_ddb.c	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/vps/vps_ddb.c	2013-06-24 14:20:40.000000000 +0200
@@ -0,0 +1,285 @@
+/*-
+ * Copyright (c) 2009-2013 Klaus P. Ohrhallinger <k@7he.at>
+ * All rights reserved.
+ *
+ * Development of this software was partly funded by:
+ *    TransIP.nl <http://www.transip.nl/>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/* $Id: vps_ddb.c 180 2013-06-14 16:52:13Z klaus $ */
+
+#include "opt_inet.h"
+#include "opt_inet6.h"
+#include "opt_global.h"
+#include "opt_ddb.h"
+
+#ifdef VPS
+#ifdef DDB
+
+#include <sys/cdefs.h>
+
+#include <sys/param.h>
+#include <sys/kernel.h>
+#include <sys/mbuf.h>
+#include <sys/module.h>
+#include <sys/refcount.h>
+#include <sys/queue.h>
+#include <sys/socket.h>
+#include <sys/sockio.h>
+#include <sys/sysctl.h>
+#include <sys/types.h>
+
+#include <net/bpf.h>
+#include <net/ethernet.h>
+#include <net/if.h>
+#include <net/if_clone.h>
+#include <net/if_var.h>
+#include <net/if_types.h>
+#include <net/netisr.h>
+#include <net/route.h>
+#include <net/vnet.h>
+
+#include <netinet/in.h>
+#include <netinet/ip.h>
+
+#include "vps_user.h"
+#include "vps.h"
+#include "vps2.h"
+
+static int vps_ddb_refcnt;
+
+static const char *
+vps_statusstr(int status)
+{
+	switch (status) {
+	/*
+	case VPS_ST_INITISDYING:
+		return ("init_is_dying");
+	*/
+	case VPS_ST_CREATING:
+		return ("creating");
+	case VPS_ST_RUNNING:
+		return ("running");
+	case VPS_ST_SUSPENDED:
+		return ("suspended");
+	case VPS_ST_SNAPSHOOTING:
+		return ("snapshooting");
+	case VPS_ST_RESTORING:
+		return ("restoring");
+	case VPS_ST_DYING:
+		return ("dying");
+	case VPS_ST_DEAD:
+		return ("dead");
+	default:
+		return ("unknown");
+	}
+}
+
+#ifdef DDB
+#include <ddb/ddb.h>
+#include <ddb/db_command.h>
+#include <ddb/db_sym.h>
+
+DB_SHOW_COMMAND(vps, db_show_vps)
+{
+	db_expr_t decaddr;
+	struct vps *vps, *vps2;
+	struct proc *p;
+	int i;
+#ifdef INVARIANTS
+	struct vps_ref *ref;
+#endif
+
+	if (!have_addr) {
+		/* Summary list of all vps instances. */
+		db_printf("idx       addr     [name]             parent\n");
+		i = 0;
+		LIST_FOREACH(vps, &vps_head, vps_all) {
+			db_printf("%d %8p [%16s] %8p\n",
+				i, vps, vps->vps_name, vps->vps_parent);
+			i++;
+		}
+		db_printf("show vps <addr/index>\n");
+	} else {
+		decaddr = db_hex2dec(addr);
+		if (decaddr == -1) {
+			vps = (struct vps *)addr;
+		} else {
+			vps = NULL;
+			i = 0;
+			LIST_FOREACH(vps2, &vps_head, vps_all) {
+				if (i == decaddr) {
+					vps = vps2;
+					break;
+				}
+				i++;
+			}
+			if (vps == NULL)
+				return;
+		}
+
+		/* Detailed view of one instance. */
+		db_printf("vps:             %p\n", vps);
+		db_printf("name:            [%s]\n", vps->vps_name);
+		db_printf("parent:          %p\n", vps->vps_parent);
+		db_printf("status:          %s\n",
+		    vps_statusstr(vps->vps_status));
+		db_printf("vnet:            %p\n", vps->vnet);
+		db_printf("nprocs:          %d\n", VPS_VPS(vps, nprocs));
+		db_printf("nprocs_zomb:     %d\n",
+		    VPS_VPS(vps, nprocs_zomb));
+		db_printf("sockets:         %d\n", vps->vnet->vnet_sockcnt);
+		db_printf("refcnt:          %d\n", vps->vps_refcnt);
+		db_printf("restore_count:   %d\n", vps->restore_count);
+		db_printf("processes: \n");
+		LIST_FOREACH(p, &VPS_VPS(vps, allproc), p_list) {
+			db_printf("    p=%p pid=%d p_state=%d\n",
+				p, p->p_pid, p->p_state);
+		}
+		db_printf("zombie processes: \n");
+		LIST_FOREACH(p, &VPS_VPS(vps, zombproc), p_list) {
+			db_printf("    p=%p pid=%d p_state=%d\n",
+				p, p->p_pid, p->p_state);
+		}
+#ifdef INVARIANTS
+		db_printf("references: \n");
+		TAILQ_FOREACH(ref, &vps->vps_ref_head, list) {
+			db_printf("    ref=%p arg=%p ticks=%zu\n",
+				ref, ref->arg, (size_t)ref->ticks);
+		}
+#endif
+	}
+}
+
+/*
+ * For changing the current thread's vps reference for being able to use
+ * ddb commands like ''show all procs'' or ''show files''.
+ * Should be reset to original values _before_ leaving the debugger prompt !
+ */
+DB_COMMAND(setcurvps, db_setcurvps)
+{
+	db_expr_t decaddr;
+	struct vps *vps, *vps2;
+	int i;
+
+	if (!have_addr) {
+		db_printf("setcurvps <addr/index>\n");
+		return;
+	}
+
+	decaddr = db_hex2dec(addr);
+	if (decaddr == -1) {
+		vps = (struct vps *)addr;
+	} else {
+		vps = NULL;
+		i = 0;
+		LIST_FOREACH(vps2, &vps_head, vps_all) {
+			if (i == decaddr) {
+				vps = vps2;
+				break;
+			}
+			i++;
+		}
+		if (vps == NULL)
+			return;
+	}
+
+	db_printf("curthread=%p\n"
+		  "   td_vps=%p\n"
+		  "   td_ucred=%p\n"
+		  , curthread
+		  , curthread->td_vps
+		  , curthread->td_ucred
+		 );
+	if (curthread->td_ucred)
+		db_printf("   td_ucred->cr_vps=%p\n",
+		    curthread->td_ucred->cr_vps);
+
+	curthread->td_vps = vps;
+	if (curthread->td_ucred)
+		curthread->td_ucred->cr_vps = vps;
+
+	db_printf("curthread=%p\n"
+		  "   td_vps=%p\n"
+		  "   td_ucred=%p\n"
+		  , curthread
+		  , curthread->td_vps
+		  , curthread->td_ucred
+		 );
+	if (curthread->td_ucred)
+		db_printf("   td_ucred->cr_vps=%p\n",
+		    curthread->td_ucred->cr_vps);
+}
+
+DB_SHOW_COMMAND(ucred, db_show_ucred)
+{
+	struct ucred *ucred;
+
+	if (!have_addr) {
+		db_printf("show ucred <addr>\n");
+		return;
+	}
+
+	ucred = (struct ucred *)addr;
+
+	db_printf("ucred:       %p\n", ucred);
+	db_printf("cr_ref:      %d\n", ucred->cr_ref);
+	db_printf("cr_vps:      %p\n", ucred->cr_vps);
+	db_printf("cr_prison:   %p\n", ucred->cr_prison);
+	db_printf("cr_uid:	%d\n", ucred->cr_uid);
+	db_printf("cr_gid:	%d\n", ucred->cr_gid);
+}
+#endif /* DDB */
+
+static int
+vps_ddb_modevent(module_t mod, int type, void *data)
+{
+
+        switch (type) {
+        case MOD_LOAD:
+		refcount_init(&vps_ddb_refcnt, 0);
+                break;
+        case MOD_UNLOAD:
+		if (vps_ddb_refcnt > 0)
+			return (EBUSY);
+                break;
+        default:
+                return (EOPNOTSUPP);
+        }
+        return (0);
+}
+
+static moduledata_t vps_ddb_mod = {
+        "vps_ddb",
+        vps_ddb_modevent,
+        0
+};
+
+DECLARE_MODULE(vps_ddb, vps_ddb_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
+MODULE_VERSION(vps_ddb, 1);
+
+#endif /* DDB */
+#endif /* VPS */
+
+/* EOF */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/vps/vps_dev.c head/sys/vps/vps_dev.c
--- clean-head/sys/vps/vps_dev.c	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/vps/vps_dev.c	2013-06-24 14:20:40.000000000 +0200
@@ -0,0 +1,421 @@
+/*-
+ * Copyright (c) 2009-2013 Klaus P. Ohrhallinger <k@7he.at>
+ * All rights reserved.
+ *
+ * Development of this software was partly funded by:
+ *    TransIP.nl <http://www.transip.nl/>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+static const char vpsid[] =
+    "$Id: vps_dev.c 153 2013-06-03 16:18:17Z klaus $";
+
+#include <sys/cdefs.h>
+
+#include "opt_ddb.h"
+#include "opt_global.h"
+
+#ifdef VPS
+
+#include <sys/param.h>
+#include <sys/types.h>
+#include <sys/limits.h>
+#include <sys/kernel.h>
+#include <sys/linker.h>
+#include <sys/lock.h>
+#include <sys/malloc.h>
+#include <sys/conf.h>
+#include <sys/libkern.h>
+#include <sys/module.h>
+#include <sys/sysctl.h>
+#include <sys/file.h>
+#include <sys/proc.h>
+#include <sys/ucred.h>
+#include <sys/ioccom.h>
+#include <sys/socket.h>
+#include <sys/mman.h>
+#include <sys/jail.h>
+
+#include <vm/pmap.h>
+
+#include <net/if.h>
+#include <netinet/in.h>
+
+#include "vps_user.h"
+#include "vps_int.h"
+#include "vps.h"
+#include "vps2.h"
+
+#ifdef DIAGNOSTIC
+
+#define DBGDEV	if (debug_dev) printf
+
+static int debug_dev = 0;
+SYSCTL_INT(_debug, OID_AUTO, vps_dev_debug, CTLFLAG_RW, &debug_dev, 0, "");
+
+#else
+
+#define DBGDEV(x, ...)
+
+#endif /* DIAGNOSTIC */
+
+static int vps_dev_refcnt = 0;
+
+static caddr_t vps_dev_emptypage;
+
+static struct cdev *vps_dev_p;
+static d_fdopen_t  vps_dev_fdopen;
+static d_open_t  vps_dev_open;
+static d_close_t vps_dev_close;
+static d_ioctl_t vps_dev_ioctl;
+static d_mmap_t  vps_dev_mmap;
+
+static struct cdevsw vps_dev_cdevsw = {
+	.d_version = D_VERSION,
+	.d_name = "vps control device",
+	.d_fdopen = vps_dev_fdopen,
+	.d_open = vps_dev_open,
+	.d_close = vps_dev_close,
+	.d_ioctl = vps_dev_ioctl,
+	.d_mmap = vps_dev_mmap,
+	.d_flags = D_TRACKCLOSE,
+};
+
+LIST_HEAD(vps_dev_ctx_le, vps_dev_ctx) vps_dev_ctx_head;
+
+MALLOC_DEFINE(M_VPS_DEV, "vps_dev",
+    "Virtual Private Systems Device memory");
+
+/* ----------------------- */
+
+static int
+vps_dev_attach(void)
+{
+
+	vps_dev_emptypage = malloc(PAGE_SIZE, M_VPS_DEV, M_WAITOK | M_ZERO);
+
+	vps_dev_p = make_dev(&vps_dev_cdevsw, 123, UID_ROOT,
+	    GID_WHEEL, 0600, "vps");
+
+	LIST_INIT(&vps_dev_ctx_head);
+
+	DBGDEV("%s: init done\n", __func__);
+
+	return (0);
+}
+
+static int
+vps_dev_detach(void)
+{
+
+	if (vps_dev_refcnt > 0)
+		return (EBUSY);
+
+	destroy_dev(vps_dev_p);
+
+	free(vps_dev_emptypage, M_VPS_DEV);
+
+	DBGDEV("%s: cleanup done\n", __func__);
+
+	return (0);
+}
+
+static int
+vps_dev_modevent(module_t mod, int type, void *data)
+{
+	int error;
+
+	switch (type) {
+	case MOD_LOAD:
+		error = vps_dev_attach();
+		break;
+	case MOD_UNLOAD:
+		error = vps_dev_detach();
+		break;
+	default:
+		error = EOPNOTSUPP;
+		break;
+	}
+	return (error);
+}
+
+static moduledata_t vps_dev_mod = {
+	"vps_dev",
+	vps_dev_modevent,
+	0
+};
+
+DECLARE_MODULE(vps_dev, vps_dev_mod, SI_SUB_PSEUDO, SI_ORDER_ANY);
+
+static struct vps_dev_ctx *
+vps_dev_get_ctx(struct thread *td)
+{
+	struct vps_dev_ctx *ctx;
+
+	if (jailed(td->td_ucred)) {
+		printf("%s: td is jailed --> denying any vps-device "
+		    "action !\n", __func__);
+		return (NULL);
+	}
+
+	LIST_FOREACH(ctx, &vps_dev_ctx_head, list)
+		if (ctx->fp == td->td_fpop) {
+			DBGDEV("%s: td->td_fpop=%p ctx=%p\n",
+				__func__, td->td_fpop, ctx);
+			return (ctx);
+		}
+
+	printf("%s: ######## dev_ctx not found for td=%p td->td_fpop=%p "
+	    "pid=%d\n", __func__, td, td->td_fpop, td->td_proc->p_pid);
+
+	return (NULL);
+}
+
+static int
+vps_dev_fdopen(struct cdev *dev, int fflags, struct thread *td,
+    struct file *fp)
+{
+	struct vps_dev_ctx *ctx;
+
+	if (jailed(td->td_ucred)) {
+		printf("%s: td is jailed --> denying any vps-device "
+		    "action !\n", __func__);
+		return (EPERM);
+	}
+
+	atomic_add_int(&vps_dev_refcnt, 1);
+
+	ctx = malloc(sizeof(*ctx), M_VPS_DEV, M_WAITOK | M_ZERO);
+	ctx->fp = fp;
+
+	LIST_INSERT_HEAD(&vps_dev_ctx_head, ctx, list);
+
+	DBGDEV("%s: done refcnt=%d ctx=%p\n",
+	    __func__, vps_dev_refcnt, ctx);
+
+	return (0);
+}
+
+static int
+vps_dev_open(struct cdev *dev, int flags, int fmt, struct thread *td)
+{
+
+	return (EOPNOTSUPP);
+}
+
+static int
+vps_dev_close(struct cdev *dev, int flags, int fmt, struct thread *td)
+{
+	struct vps_dev_ctx *ctx;
+
+	ctx = vps_dev_get_ctx(td);
+
+	DBGDEV("%s: ctx=%p\n", __func__, ctx);
+
+	if (ctx == NULL) {
+		printf("%s: ctx == NULL !\n", __func__);
+		return (0);
+	}
+
+	LIST_REMOVE(ctx, list);
+
+	if (ctx->snapst && vps_func->vps_snapshot_finish)
+		vps_func->vps_snapshot_finish(ctx, NULL);
+
+	if (ctx->data)
+		free(ctx->data, M_VPS_DEV);
+
+	free(ctx, M_VPS_DEV);
+
+	atomic_subtract_int(&vps_dev_refcnt, 1);
+
+	DBGDEV("%s: done refcnt=%d ctx=%p\n",
+	    __func__, vps_dev_refcnt, ctx);
+
+	return (0);
+}
+
+static int
+vps_dev_ioctl(struct cdev *dev, u_long cmd, caddr_t data,
+        int flags, struct thread *td)
+{
+	struct vps *vps;
+	struct vps_dev_ctx *ctx;
+	int error;
+
+	ctx = vps_dev_get_ctx(td);
+	if (ctx == NULL) {
+		printf("%s: ctx == NULL !\n", __func__);
+		return (EBADF);
+	}
+
+	/* Needed for conext lookup in mmap pager function. */
+	ctx->td = td;
+
+	error = 0;
+	vps = TD_TO_VPS(td);
+
+	KASSERT(vps != NULL, ("%s: vps == NULL\n", __func__));
+
+	DBGDEV("%s: td=%p ctx=%p cmd=0x%08lx\n",
+	   __func__, td, ctx, cmd);
+
+	switch (cmd) {
+	case VPS_IOC_LIST:
+		error = vps_ioc_list(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_CREAT:
+		error = vps_ioc_create(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_DESTR:
+		error = vps_ioc_destroy(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_SWITCH:
+		error = vps_ioc_switch(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_SWITWT:
+		error = vps_ioc_switchwait(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_IFMOVE:
+		error = vps_ioc_ifmove(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_SUSPND:
+		error = vps_ioc_suspend(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_RESUME:
+		error = vps_ioc_resume(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_ABORT:
+		error = vps_ioc_abort(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_SNAPST:
+		error = vps_ioc_snapshot(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_SNAPSTFIN:
+		error = vps_ioc_snapshot_finish(vps, ctx, cmd, data, flags,
+		    td);
+		break;
+	case VPS_IOC_RESTOR:
+		error = vps_ioc_restore(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_ARGGET:
+		error = vps_ioc_argget(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_ARGSET:
+		error = vps_ioc_argset(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_GETXINFO:
+		error = vps_ioc_getextinfo(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_FSCALCPATH:
+		error = vps_ioc_fscalcpath(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_FSCALC:
+		error = vps_ioc_fscalc(vps, ctx, cmd, data, flags, td);
+		break;
+	case VPS_IOC_GETCONSFD:
+		error = vps_ioc_getconsfd(vps, ctx, cmd, data, flags, td);
+		break;
+	default:
+		error = EOPNOTSUPP;
+		break;
+	}
+
+	return (error);
+}
+
+__attribute__((noinline))
+static int
+vps_dev_mmap(struct cdev *dev, vm_ooffset_t offset,
+        vm_paddr_t *paddr, int nprot, vm_memattr_t *memattr)
+{
+	struct vps_dev_ctx *ctx, *ctx2;
+	struct vps *vps;
+	int error;
+
+	/* td->td_fpop is not set here.
+	ctx = vps_dev_get_ctx(curthread);
+	*/
+
+	ctx = NULL;
+	LIST_FOREACH(ctx2, &vps_dev_ctx_head, list)
+		if (ctx2->td == curthread) {
+			ctx = ctx2;
+			break;
+		}
+
+	if (ctx == NULL) {
+		/*
+		 * Returning error from this function leads to panic.
+		 * Better return an empty page than let the
+		 * user cause a kernel panic.
+		 */
+		printf("%s: ctx == NULL !\n", __func__);
+		goto invalid;
+	}
+
+	if (ctx->data == NULL && ctx->cmd != VPS_IOC_SNAPST) {
+		printf("%s: ctx->data == NULL !\n", __func__);
+		goto invalid;
+	}
+
+	error = 0;
+	vps = TD_TO_VPS(curthread);
+
+	/* XXX assert vps != NULL */
+
+	if (offset < 0) {
+		printf("%s: offset=%zu < 0\n",
+		    __func__, (size_t)offset);
+		goto invalid;
+	}
+
+	if (nprot != PROT_READ) {
+		printf("%s: nprot=%d != PROT_READ\n",
+		    __func__, nprot);
+		goto invalid;
+	}
+
+	if (1) {
+		/* VPS_IOC_LIST */
+
+		if (offset > ctx->length) {
+			printf("%s: offset=%zu > ctx->length=%zu\n",
+			    __func__, (size_t)offset, ctx->length);
+			goto invalid;
+		}
+
+		*paddr = (vm_paddr_t)vtophys(ctx->data + offset);
+	}
+
+	return (0);
+
+  invalid:
+	*paddr = (vm_paddr_t)vtophys(vps_dev_emptypage);
+
+	return (0);
+}
+
+#endif /* VPS */
+
+/* EOF */
diff -Naupr -x .svn -x 'rsync_vps.*' -I '$Id.*$' -I '$FreeBSD.*$' clean-head/sys/vps/vps_devfsruleset.h head/sys/vps/vps_devfsruleset.h
--- clean-head/sys/vps/vps_devfsruleset.h	1970-01-01 01:00:00.000000000 +0100
+++ head/sys/vps/vps_devfsruleset.h	2013-06-24 14:20:40.000000000 +0200
@@ -0,0 +1,299 @@
+/*-
+ * Copyright (c) 2009-2013 Klaus P. Ohrhallinger <k@7he.at>
+ * All rights reserved.
+ *
+ * Development of this software was partly funded by:
+ *    TransIP.nl <http://www.transip.nl/>
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ *    notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ *    notice, this list of conditions and the following disclaimer in the
+ *    documentation and/or other materials provided with the distribution.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ * OR SERVICES, LOSS OF USE, DATA, OR PROFITS, OR BUSINESS INTERRUPTION)
+ * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ * SUCH DAMAGE.
+ */
+
+/* $Id: vps_devfsruleset.h 126 2013-04-07 15:55:54Z klaus $ */
+
+#ifndef _VPS_DEVFSRULESET_H
+#define _VPS_DEVFSRULESET_H
+
+#include <sys/cdefs.h>
+
+struct devfs_rule vps_devfs_ruleset_default[] = {
+	/* Hide all. */
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 100),
+	.dr_icond = 0,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_HIDE,
+	},
+	/* Unhide some things. */
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 200),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "null",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 201),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "zero",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 202),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "crypto",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 203),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "random",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 204),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "urandom",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 205),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "console",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 300),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyp*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 301),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyq*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 302),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyr*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 303),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptys*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 304),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyP*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 305),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyQ*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 306),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyR*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 307),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ptyS*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 308),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyp*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 309),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyq*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 310),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyr*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 311),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttys*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 312),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyP*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 313),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyQ*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 314),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyR*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 315),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyS*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 316),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "pts",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 317),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "pts/*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 318),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "pty/*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 319),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "fd",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 320),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "fd/*",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 321),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "stdin",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 322),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "stdout",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 323),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "stderr",
+	},
+	{
+	.dr_magic = DEVFS_MAGIC,
+	.dr_id = mkrid(100, 324),
+	.dr_icond = DRC_PATHPTRN,
+	.dr_iacts = DRA_BACTS,
+	.dr_bacts = DRB_UNHIDE,
+	.dr_pathptrn = "ttyv*",
+	},
+};
+
+#endif /* _VPS_DEVFSRULESET_H */
+
+/* EOF */
